VTK: vtkFileSeriesHelper Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkFileSeriesHelper Class Reference

Helper class to process file series. More...

`#include <vtkFileSeriesHelper.h>`

Inheritance diagram for vtkFileSeriesHelper:
[legend]
Collaboration diagram for vtkFileSeriesHelper:
[legend]

## Classes
class | vtkTimeInformation

## Public Types
typedef vtkObject | Superclass
typedef bool(* | FileNameFunctorType) (vtkAlgorithm *reader, const std::string &filename)

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkFileSeriesHelper * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
unsigned int | GetNumberOfFiles () const
| Get the number of files in the series. More...
virtual bool | ReadMetaFile (const char *metafilename)
| Setup file names in the series using a meta-file. More...
virtual bool | UpdateInformation (vtkAlgorithm *reader, const FileNameFunctorType &ftor)
| vtkFileSeriesHelper needs to collect information about the nature of the fileseries. More...
virtual vtkMTimeType | GetUpdateInformationTime ()
| The time stamp for the most recent `UpdateInformation` call that did some work to update the file series. More...
const std::vector< double > & | GetTimeSteps () const
| Returns the timesteps determined. More...
const std::pair< double, double > & | GetTimeRange (bool *isvalid=nullptr) const
| Returns the time range determined. More...
void | FillTimeInformation (vtkInformation *info) const
| Fills up info with information about timesteps and timerange. More...
virtual bool | GetPartitionedFiles ()
| Returns true if the file series is a series of partitions rather than a series of timesteps. More...
std::vector< std::string > | GetActiveFiles (vtkInformation *outInfo) const
| Returns the list of files to read on current rank to satisfy the request. More...
void | RemoveAllFileNames ()
| Specify the set of files that comprise the series. More...
void | AddFileName (const char *fname)
| Specify the set of files that comprise the series. More...
void | SetFileNames (const std::vector< std::string > &filenames)
| Specify the set of files that comprise the series. More...
void | SetController (vtkMultiProcessController *)
| Get/Set the parallel controller. More...
virtual vtkMultiProcessController * | GetController ()
| Get/Set the parallel controller. More...
virtual void | SetIgnoreReaderTime (bool)
| In vtkFileSeriesHelper::UpdateInformation, vtkFileSeriesHelper tries to determine time information from the reader by making it read each of the files and then collecting the timesteps provided by each. More...
virtual bool | GetIgnoreReaderTime ()
| In vtkFileSeriesHelper::UpdateInformation, vtkFileSeriesHelper tries to determine time information from the reader by making it read each of the files and then collecting the timesteps provided by each. More...
virtual void | IgnoreReaderTimeOn ()
| In vtkFileSeriesHelper::UpdateInformation, vtkFileSeriesHelper tries to determine time information from the reader by making it read each of the files and then collecting the timesteps provided by each. More...
virtual void | IgnoreReaderTimeOff ()
| In vtkFileSeriesHelper::UpdateInformation, vtkFileSeriesHelper tries to determine time information from the reader by making it read each of the files and then collecting the timesteps provided by each. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkFileSeriesHelper * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkFileSeriesHelper * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkFileSeriesHelper ()
| ~vtkFileSeriesHelper () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkMultiProcessController * | Controller
std::vector< std::string > | FileNames
bool | IgnoreReaderTime
bool | PartitionedFiles
std::vector< vtkTimeInformation > | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Helper class to process file series.

vtkFileSeriesHelper is intended to be a helper class that processes file series. File series encountered in ParaView are of two types: temporal or spatial. This class encapsulates logic to determine which form it is in.

Currently, this is used by vtkCGNSFileSeriesReader. Eventually, we should be able to refactor vtkFileSeriesReader to use this class.

Definition at line 33 of file vtkFileSeriesHelper.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkFileSeriesHelper::Superclass

Definition at line 37 of file vtkFileSeriesHelper.h.

## ◆ FileNameFunctorType

typedef bool(* vtkFileSeriesHelper::FileNameFunctorType) (vtkAlgorithm *reader, const std::string &filename)

Definition at line 40 of file vtkFileSeriesHelper.h.

## Constructor & Destructor Documentation

## ◆ vtkFileSeriesHelper()

vtkFileSeriesHelper::vtkFileSeriesHelper | ( |  | ) |
| protected

## ◆ ~vtkFileSeriesHelper()

vtkFileSeriesHelper::~vtkFileSeriesHelper | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkFileSeriesHelper* vtkFileSeriesHelper::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkFileSeriesHelper::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkFileSeriesHelper::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkFileSeriesHelper* vtkFileSeriesHelper::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkFileSeriesHelper::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkFileSeriesHelper* vtkFileSeriesHelper::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkFileSeriesHelper::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ RemoveAllFileNames()

void vtkFileSeriesHelper::RemoveAllFileNames | ( |  | ) |

Specify the set of files that comprise the series.

## ◆ AddFileName()

void vtkFileSeriesHelper::AddFileName | ( | const char * | fname | ) |

Specify the set of files that comprise the series.

## ◆ SetFileNames()

void vtkFileSeriesHelper::SetFileNames | ( | const std::vector< std::string > & | filenames | ) |

Specify the set of files that comprise the series.

## ◆ GetNumberOfFiles()

unsigned int vtkFileSeriesHelper::GetNumberOfFiles | ( |  | ) | const

Get the number of files in the series.

## ◆ ReadMetaFile()

virtual bool vtkFileSeriesHelper::ReadMetaFile | ( | const char * | metafilename | ) |
| virtual

Setup file names in the series using a meta-file.

The meta-file is simply lists the names of the files in the series sequentially in an ASCII file. All files in the file are relative to the location of the meta-file or absolute paths.

This will remove an preexisting files added to the helper irrespective of whether reading of the meta-file succeeded or not.

Returns
  false if failed to read the meta-file, true otherwise.

## ◆ SetController()

void vtkFileSeriesHelper::SetController | ( | vtkMultiProcessController * |  | ) |

Get/Set the parallel controller.

By default vtkMultiProcessController::GetGlobalController() will be used.

## ◆ GetController()

virtual vtkMultiProcessController* vtkFileSeriesHelper::GetController | ( |  | ) |
| virtual

Get/Set the parallel controller.

By default vtkMultiProcessController::GetGlobalController() will be used.

## ◆ SetIgnoreReaderTime()

virtual void vtkFileSeriesHelper::SetIgnoreReaderTime | ( | bool |  | ) |
| virtual

In vtkFileSeriesHelper::UpdateInformation, vtkFileSeriesHelper tries to determine time information from the reader by making it read each of the files and then collecting the timesteps provided by each.

Sometimes, however, the time steps in the files in the fileseries are invalid (or same) in which case one may want to to simply use the time-step index as the time value. For that case, one should set `IgnoreReaderTime` to `true` (default: `false`).

## ◆ GetIgnoreReaderTime()

virtual bool vtkFileSeriesHelper::GetIgnoreReaderTime | ( |  | ) |
| virtual

In vtkFileSeriesHelper::UpdateInformation, vtkFileSeriesHelper tries to determine time information from the reader by making it read each of the files and then collecting the timesteps provided by each.

Sometimes, however, the time steps in the files in the fileseries are invalid (or same) in which case one may want to to simply use the time-step index as the time value. For that case, one should set `IgnoreReaderTime` to `true` (default: `false`).

## ◆ IgnoreReaderTimeOn()

virtual void vtkFileSeriesHelper::IgnoreReaderTimeOn | ( |  | ) |
| virtual

In vtkFileSeriesHelper::UpdateInformation, vtkFileSeriesHelper tries to determine time information from the reader by making it read each of the files and then collecting the timesteps provided by each.

Sometimes, however, the time steps in the files in the fileseries are invalid (or same) in which case one may want to to simply use the time-step index as the time value. For that case, one should set `IgnoreReaderTime` to `true` (default: `false`).

## ◆ IgnoreReaderTimeOff()

virtual void vtkFileSeriesHelper::IgnoreReaderTimeOff | ( |  | ) |
| virtual

In vtkFileSeriesHelper::UpdateInformation, vtkFileSeriesHelper tries to determine time information from the reader by making it read each of the files and then collecting the timesteps provided by each.

Sometimes, however, the time steps in the files in the fileseries are invalid (or same) in which case one may want to to simply use the time-step index as the time value. For that case, one should set `IgnoreReaderTime` to `true` (default: `false`).

## ◆ UpdateInformation()

virtual bool vtkFileSeriesHelper::UpdateInformation | ( | vtkAlgorithm * | reader,
|  | const FileNameFunctorType & | ftor
| ) |  |
| virtual

vtkFileSeriesHelper needs to collect information about the nature of the fileseries.

This method should be called to collect this information.

This method has any effect only when the filenames (or any ivar that could affect the times e.g. IgnoreReaderTime) have changed, hence calling this repeatedly is acceptable.

When this method does any work, it updates `this->UpdateInformationTime`. One can use `GetUpdateInformationTime` to check if the file series has potentially been changed.

Parameters

  [in] | reader | pointer to the single file reader to use.
  [in] | ftor | callback to set the filename on the reader.

Returns
  false if no filenames are specified or failed to collect meta-data.

## ◆ GetUpdateInformationTime()

virtual vtkMTimeType vtkFileSeriesHelper::GetUpdateInformationTime | ( |  | ) |
| virtual

The time stamp for the most recent `UpdateInformation` call that did some work to update the file series.

## ◆ GetTimeSteps()

const std::vector<double>& vtkFileSeriesHelper::GetTimeSteps | ( |  | ) | const
| inline

Returns the timesteps determined.

This method will return valid values only after a successful call to `UpdateInformation`.

Definition at line 122 of file vtkFileSeriesHelper.h.

## ◆ GetTimeRange()

const std::pair<double, double>& vtkFileSeriesHelper::GetTimeRange | ( | bool * | isvalid = `nullptr` | ) | const
| inline

Returns the time range determined.

Definition at line 127 of file vtkFileSeriesHelper.h.

## ◆ FillTimeInformation()

void vtkFileSeriesHelper::FillTimeInformation | ( | vtkInformation * | info | ) | const

Fills up info with information about timesteps and timerange.

## ◆ GetPartitionedFiles()

virtual bool vtkFileSeriesHelper::GetPartitionedFiles | ( |  | ) |
| virtual

Returns true if the file series is a series of partitions rather than a series of timesteps.

## ◆ GetActiveFiles()

std::vector<std::string> vtkFileSeriesHelper::GetActiveFiles | ( | vtkInformation * | outInfo | ) | const

Returns the list of files to read on current rank to satisfy the request.

Requested time and piece information is obtained from `outInfo`. If `outInfo` has not piece information, however, than `this->Controller` is used.

Parameters

  outInfo | vtkInformation object with `UPDATE_*` keys that indicate the requested time and piece information.

## Member Data Documentation

## ◆ Controller

vtkMultiProcessController* vtkFileSeriesHelper::Controller
| protected

Definition at line 185 of file vtkFileSeriesHelper.h.

## ◆ FileNames

std::vector<std::string> vtkFileSeriesHelper::FileNames
| protected

Definition at line 186 of file vtkFileSeriesHelper.h.

## ◆ IgnoreReaderTime

bool vtkFileSeriesHelper::IgnoreReaderTime
| protected

Definition at line 187 of file vtkFileSeriesHelper.h.

## ◆ PartitionedFiles

bool vtkFileSeriesHelper::PartitionedFiles
| protected

Definition at line 188 of file vtkFileSeriesHelper.h.

## ◆ Information

std::vector<vtkTimeInformation> vtkFileSeriesHelper::Information
| protected

Definition at line 189 of file vtkFileSeriesHelper.h.

The documentation for this class was generated from the following file:

- IO/CGNS/vtkFileSeriesHelper.h